#include <string.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

#undef NULL
#include "../include/param.h"
#include "../include/user.h"
#include "../include/proc.h"
#include "../include/file.h"
#include "../include/buf.h"
#include "../include/reg.h"

int regs[16];
struct proc procd;

#include "net.h"
#include "ucb.h"
#include "ifcb.h"

static struct con con;
static char msg[512];

int
dowork (cnt)
{
   struct ifcb *lp;
   int i;

   tcp_input (NULL, NULL);

   for (i = 0; i < cnt; i++)
   {
      for (lp = ifcb; lp < &ifcb[nifcb]; lp++)
      {
         if ((*lp->if_poll) (lp) == 1)
         {
            (*lp->if_rcv) (lp);
            tcp_input (NULL, NULL);
            return 1;
         }
      }
      sleep (1);
   }
   return 0;
}

main (argc, argv)
     char **argv;
{
   struct ifcb *lp;
   char *bp;
   int sd;
   int i;
   int len;
   int port;
   int tcptest;

   sd = 0;
   tcptest = 0;
   port = 4000;
   len = 0;
   /*
    ** Scan off args 
    */

   for (i = 1; i < argc; i++)
   {
      bp = argv[i];

      if (*bp == '-')
      {
         for (bp++; *bp; bp++)
            switch (*bp)
            {
            case 't':
               tcptest = 1;
               break;

            default:
	       USAGE:
               printf ("usage: netserv [-options] port\n");
               printf (" options:\n");
               printf ("    -t           - TCP\n");
               return (1);
            }
      }
      else if (len == 0)
      {
         port = atoi(argv[i]);
	 len++;
      }
      else
         goto USAGE;
   }

   printf ("Start: port = %d, tcp = %d\n", port, tcptest);

   meminit ();
   u.u_ar0 = &regs[0];
   u.u_procp = &procd;
   u.u_error = 0;
   procd.p_pid = 3;

   for (lp = ifcb; lp < &ifcb[nifcb]; lp++)
   {
      (*lp->if_init) (lp);
   }

   memset (&con, 0, sizeof (struct con));

   if (!tcptest)
   {
      printf ("Open UDP socket\n");
      con.c_mode = CONUDP;
      con.c_fport = 0;
      con.c_lport = port;
      con.c_fcon.s_addr = 0;
      con.c_lcon.s_addr = 0;
      con.c_sbufs = con.c_rbufs = 1;

      sd = netopen (NULL, &con);
      printf ("   sd = %d, error = %d\n", sd, errno);
      if (errno)
         goto BADNESS;

      while (1)
      {
         u.u_base = msg;
         u.u_count = sizeof msg;
         netread ((struct ucb *) (file[sd].f_offset));
         len = 2048 - u.u_count;
	 printf ("   len = %d, error = %d\n", len, errno);
         if (len <= 0) {
	    break;
	 }
         u.u_base = msg;
         u.u_count = len;
         netwrite ((struct ucb *) (file[sd].f_offset));
      }
   }

   else
   {
      printf ("Open TCP socket\n");

      con.c_mode = CONTCP;
      con.c_fport = 0;
      con.c_lport = port;
      con.c_fcon.s_addr = 0;
      con.c_lcon.s_addr = 0;
      con.c_sbufs = con.c_rbufs = 1;

      sd = netopen (NULL, &con);
      printf ("   sd = %d, error = %d\n", sd, errno);
      if (errno)
         goto BADNESS;

      while (1)
      {
         u.u_base = msg;
         u.u_count = sizeof msg;
         netread ((struct ucb *) (file[sd].f_offset));
         len = 2048 - u.u_count;
	 printf ("   len = %d, error = %d\n", len, errno);
         if (len <= 0) {
	    break;
	 }
         u.u_base = msg;
         u.u_count = len;
         netwrite ((struct ucb *) (file[sd].f_offset));
      }
   }

 BADNESS:
   if (errno)
      printf ("ERROR = %d\n", errno);
   return 0;
}

/* netmain.c */
netlog (mp)
     register struct mbuf *mp;
{
   m_freem (mp);
}

/* OS stubs */

void
iput ()
{
   ;
}

int
suser ()
{
   return 1;
}

void
wakeup ()
{
   ;
}

void
ksleep ()
{
   dowork(1);
}

void
psignal ()
{
   ;
}

int
copyin (dst, src, cnt)
     char *dst, *src;
     int cnt;
{
   memcpy (dst, src, cnt);
   return cnt;
}

int
copyout (dst, src, cnt)
     char *dst, *src;
     int cnt;
{
   memcpy (dst, src, cnt);
   return cnt;
}

void
iomove (kdata, n, flag)
     char *kdata;
     register int n, flag;
{
   if (u.u_segflg)
   {
      /* copy within kernel space */
      if (flag == B_WRITE)
         memcpy (kdata, u.u_base, n);
      else
         memcpy (u.u_base, kdata, n);
   }
   else
   {
      /* copy a block from/to user space */
      if (flag == B_WRITE)
         copyin (kdata, u.u_base, n);
      else
         copyout (u.u_base, kdata, n);
   }
   u.u_base += n;
   u.u_offset += n;
   u.u_count -= n;
}

int
ufalloc ()
{
   register int i;

   for (i = 0; i < NOFILE; i++)
      if (u.u_ofile[i] == NULL)
      {
         u.u_ar0[R0] = i;
         return (i);
      }
   u.u_error = EMFILE;
   return (-1);
}

struct file *
falloc ()
{
   register struct file *fp;
   register int i;

   i = ufalloc ();
   if (i < 0)
      return (NULL);
   for (fp = &file[0]; fp < &file[NFILE]; fp++)
      if (fp->f_count == 0)
      {
         u.u_ofile[i] = fp;
         fp->f_count++;
         fp->f_offset = 0;
         return (fp);
      }
   write (2, "no file\n", 8);
   u.u_error = ENFILE;
   return (NULL);
}

int
spl0 ()
{
   return 0;
}

int
spl4 ()
{
   return 0;
}

int
spl5 ()
{
   return 0;
}

int
splx ()
{
   return 0;
}
