#include <string.h>
#include <stdio.h>

#undef NULL
#include "../include/param.h"
#include "../include/user.h"
#include "../include/proc.h"
#include "../include/file.h"
#include "../include/buf.h"
#include "../include/reg.h"

int regs[16];
struct proc procd;

#include "net.h"
#include "ucb.h"
#include "ifcb.h"

struct con con;

char str[] = "Hello world!\n";
char msg[2048];
struct user u;

static unsigned long
inet_addr (ip)
     char *ip;
{
   unsigned long a;
   int digs[4];
   int i;

   a = 0;
   digs[0] = 0;
   digs[1] = 0;
   digs[2] = 0;
   digs[3] = 0;
   i = 0;
   for (; *ip; ip++)
   {
      if (*ip >= '0' && *ip <= '9')
         digs[i] = (digs[i] * 10) + (*ip - '0');
      else if (*ip == '.')
         i++;
      else
         break;
   }
   a = digs[0];
   a = (a << 8) | digs[1];
   a = (a << 8) | digs[2];
   a = (a << 8) | digs[3];
   return a;
}

int
dowork (cnt)
{
   struct ifcb *lp;
   int i;

   tcp_input (NULL, NULL);

   for (i = 0; i < cnt; i++)
   {
      for (lp = ifcb; lp < &ifcb[nifcb]; lp++)
      {
         if ((*lp->if_poll) (lp) == 1)
         {
            (*lp->if_rcv) (lp);
            tcp_input (NULL, NULL);
            return 1;
         }
      }
      sleep (1);
   }
   return 0;
}

main (argc, argv)
     char **argv;
{
   unsigned long ip_addr;
   struct ifcb *lp;
   char *bp;
   char *pip;
   int sd;
   int lcnt, i;
   int len;
   int port;
   int tcptest;
   int readreply;

   ip_addr = 0;
   lcnt = 1;
   tcptest = 0;
   readreply = 0;
   len = 0;
   port = 4000;

   /*
    ** Scan off args 
    */

   for (i = 1; i < argc; i++)
   {
      bp = argv[i];

      if (*bp == '-')
      {
         for (bp++; *bp; bp++)
            switch (*bp)
            {
            case 'n':
               i++;
               lcnt = atoi (argv[i]);
               break;

            case 'r':
               readreply = 1;
               break;

            case 't':
               tcptest = 1;
               break;

            default:
	    USAGE:
               printf ("usage: nettest [-options] ip_addr [port]\n");
               printf (" options:\n");
               printf ("    -n number    - Number of messages to send\n");
               printf ("    -r           - Read reply\n");
               printf ("    -t           - Send over TCP\n");
               return (1);
            }
      }
      else if (len == 0)
      {
         pip = argv[i];
	 len++;
      }
      else if (len == 1)
      {
         port = atoi (argv[i]);
	 len++;
      }
      else 
      {
         goto USAGE;
      }
   }

   ip_addr = inet_addr (pip);
   printf
      ("Start: ip_addr = %s, port = %d, reply = %d, tcp = %d, count = %d\n",
       pip, port, readreply, tcptest, lcnt);

   if (ip_addr == 0)
      goto USAGE;

   meminit ();
   u.u_ar0 = &regs[0];
   u.u_procp = &procd;
   u.u_error = 0;
   procd.p_pid = 3;

   for (lp = ifcb; lp < &ifcb[nifcb]; lp++)
   {
      (*lp->if_init) (lp);
   }

   if (!tcptest)
   {
      printf ("Open UDP socket\n");
      con.c_mode = CONUDP;
      con.c_fcon.s_addr = ip_addr;
      con.c_lcon.s_addr = ip_addr;
      con.c_fport = port;
      con.c_lport = port;

      netopen (NULL, &con);
      if (u.u_error)
         goto BADNESS;
      sd = u.u_ar0[R0];
      printf ("socket# %d\n", sd);

      for (i = 0; i < lcnt; i++)
      {
         printf ("Write to socket: %d\n", i);
         u.u_base = str;
         u.u_count = strlen (str);
         netwrite ((struct ucb *) (file[sd].f_offset));
         if (u.u_error)
            goto BADNESS;

         if (readreply)
         {
            if (dowork (5))
            {
               printf ("Read from socket\n");
               u.u_base = msg;
               u.u_count = 2048;
               netread ((struct ucb *) (file[sd].f_offset));
               if (u.u_error)
                  goto BADNESS;
               printf ("Received %d bytes\n", 2048 - u.u_count);
               printf ("Message: %s\n", msg);
            }
         }
         else
         {
            dowork (0);
         }
      }
   }
   else
   {
      printf ("Open TCP client\n");

      con.c_mode = CONTCP | CONACT;
      con.c_fcon.s_addr = ip_addr;
      con.c_lcon.s_addr = 0;
      con.c_fport = port;
      con.c_lport = 5000;
      con.c_timeo = 60;

      netopen (NULL, &con);
      if (u.u_error)
         goto BADNESS;
      sd = u.u_ar0[R0];
      printf ("client socket# %d\n", sd);
      dowork (1);

      for (i = 0; i < lcnt; i++)
      {
         printf ("Write to client socket: %d\n", i);
         u.u_base = str;
         u.u_count = strlen (str);
         netwrite ((struct ucb *) (file[sd].f_offset));
         if (u.u_error)
            goto BADNESS;

         if (readreply)
         {
            if (dowork (5))
            {
               printf ("Read from server socket\n");
               u.u_base = msg;
               u.u_count = 2048;
               netread ((struct ucb *) (file[sd].f_offset));
	       if (u.u_error)
		   goto BADNESS;
               printf ("Received %d bytes\n", 2048 - u.u_count);
               printf ("Message: %s\n", msg);
            }
         }
         else
         {
            dowork (0);
         }
      }
      netclose (&file[sd]);
      dowork (5);
   }


   return 0;
 BADNESS:
   printf ("ERROR = %d\n", u.u_error);
   return 1;
}

/* netmain.c */
netlog (mp)
     register struct mbuf *mp;
{
   m_freem (mp);
}

/* OS stubs */

void
iput ()
{
   ;
}

int
suser ()
{
   return 1;
}

void
wakeup ()
{
   ;
}

void
ksleep ()
{
   dowork (1);
}

void
psignal ()
{
   ;
}

int
copyin (dst, src, cnt)
     char *dst, *src;
     int cnt;
{
   memcpy (dst, src, cnt);
   return cnt;
}

int
copyout (dst, src, cnt)
     char *dst, *src;
     int cnt;
{
   memcpy (dst, src, cnt);
   return cnt;
}

void
iomove (kdata, n, flag)
     char *kdata;
     register int n, flag;
{
   if (u.u_segflg)
   {
      /* copy within kernel space */
      if (flag == B_WRITE)
         memcpy (kdata, u.u_base, n);
      else
         memcpy (u.u_base, kdata, n);
   }
   else
   {
      /* copy a block from/to user space */
      if (flag == B_WRITE)
         copyin (kdata, u.u_base, n);
      else
         copyout (u.u_base, kdata, n);
   }
   u.u_base += n;
   u.u_offset += n;
   u.u_count -= n;
}

int
ufalloc ()
{
   register int i;

   for (i = 0; i < NOFILE; i++)
      if (u.u_ofile[i] == NULL)
      {
         u.u_ar0[R0] = i;
         return (i);
      }
   u.u_error = EMFILE;
   return (-1);
}

struct file *
falloc ()
{
   register struct file *fp;
   register int i;

   i = ufalloc ();
   if (i < 0)
      return (NULL);
   for (fp = &file[0]; fp < &file[NFILE]; fp++)
      if (fp->f_count == 0)
      {
         u.u_ofile[i] = fp;
         fp->f_count++;
         fp->f_offset = 0;
         return (fp);
      }
   write (2, "no file\n", 8);
   u.u_error = ENFILE;
   return (NULL);
}

int
spl0 ()
{
   return 0;
}

int
spl4 ()
{
   return 0;
}

int
spl5 ()
{
   return 0;
}

int
splx ()
{
   return 0;
}
