#include <stdio.h>

#define MSIZE 128				/* size of an mbuf */
#define MHEAD (2+2*sizeof(struct mbuf *))	/* mbuf hdr length (not incl data) */
#define MLEN  (MSIZE-MHEAD)			/* mbuf max data length */

#define NMBUF	128				/* total number of mbuf's */

struct mbuf {                   		/* message buffer */
	struct mbuf	*m_next;		/* -> next msg buffer in chain */
	struct mbuf	*m_act;			/* auxiliary mbuf pointer */
	unsigned char	 m_off;			/* offset in msg buf to curr. header */
	unsigned char	 m_len;			/* curr. data length in msg buf */
	unsigned char	m_dat[MLEN];		/* data storage */
};

struct mbuf mbufs[4];

static unsigned char t1[] = {
  0xA, 0x00, 0x0, 0x2, 0xA, 0x00, 0x0, 0x1, 0xF, 0xA0, 0xF, 0xA0, 0x0,
  0x15, 0x0, 0x0
  };
static unsigned char t2[] = {
  0x48, 0x65, 0x6C, 0x6C, 0x6F, 0x20, 0x77, 0x6F,
  0x72, 0x6C, 0x64, 0x21, 0xA
};

static unsigned char t3[] = {
   0x45, 0x0, 0x0, 0x29, 0x0, 0x0, 0x0, 0x0, 0xFF, 0x11, 0x0, 0x0, 0xA, 0x0,
   0x0, 0x2, 0xA, 0x0, 0x0, 0x1, 0xF, 0xA0, 0xF, 0xA0, 0x0, 0x15, 0xA5, 0x51
};

static unsigned char t4[] = {
   0x45, 0x0, 0x0, 0x29, 0x0, 0x0, 0x0, 0x0, 0xFF, 0x11, 0x0, 0x0, 0xA, 0x0,
   0x0, 0x2, 0xA, 0x0, 0x0, 0x1, 0xF, 0xA0, 0xF, 0xA0, 0x0, 0x15, 0x5A, 0xAE,
   0x48, 0x65, 0x6C, 0x6C, 0x6F, 0x20, 0x77, 0x6F, 0x72, 0x6C, 0x64, 0x21, 0xA
};

static unsigned char t5[] = {
  0x45, 0x00, 0x0, 0x29, 0x0, 0x0, 0x0, 0x0, 0xFF, 0x11, 0x0, 0x0,
  0xA, 0x00, 0x0, 0x2, 0xA, 0x00, 0x0, 0x1
};

#if 0
/*
 * TCP/IP checksum routine: one's complement of the one's complement sum of
 * the sixteen bit words of header/data
 */
#define lobyte(x) (*((char *)x) & 0xff)
#define hibyte(x) ((unsigned)((*((char *)x) & 0xff) << 8))
extern unsigned short chks1c();

unsigned short
cksum(m, len)
register struct mbuf *m;
register len;
{
	register unsigned short *w;
	register unsigned short sum;
	register mlen;

	w = (unsigned short *)((int)m + m->m_off);
	mlen = m->m_len;
	sum = 0;

	for (; len > 0; len -= 2, mlen -= 2) {

try:            if (mlen > 1) {         /* can get a word */

			if (len > 1) {
				sum = chks1c (sum, *(w++));
			} else {          /* trailing odd byte */
				sum = chks1c (sum, lobyte(w));
			}

		} else if (mlen > 0) {  /* last byte of mbuf */

			sum = chks1c (sum, lobyte(w));

			if (len > 1) {

        			/* get next good mbuf for hi byte */
        
        			while ((m = m->m_next) != NULL && 
					(mlen = m->m_len + 1) == 1);
        			if (m != NULL) {
        				w = (unsigned short *)((int)m + m->m_off);
        				sum = chks1c (sum, hibyte(w));
					w = (unsigned short *)((int)w + 1);
        			} else
        				len = 0;        /* force loop exit */
			}

		} else {                /* end of mbuf, get next and try again */

			while ((m = m->m_next) != NULL && (mlen = m->m_len) == 0);
			if (m != NULL) {
				w = (unsigned short *)((int)m + m->m_off);
				goto try;
			} else
				break;
		}
	}

	return (~sum);
}
#else
extern unsigned int cksum();
#endif

main()
{
   unsigned int sum;

   memset (mbufs, 0, sizeof (mbufs));

   mbufs[0].m_off = 112;
   mbufs[0].m_len = sizeof (t1);
   memcpy (&mbufs[0].m_dat[112-MHEAD], t1, sizeof(t1));
   mbufs[1].m_off = MHEAD;
   mbufs[1].m_len = sizeof (t2);
   memcpy (mbufs[1].m_dat, t2, sizeof(t2));
   mbufs[0].m_next = &mbufs[1];
   sum = cksum (&mbufs[0], sizeof(t1)+sizeof(t2));
   printf ("sum = >%04X\n", sum);

#if 1
   mbufs[1].m_off = 100;
   mbufs[1].m_len = sizeof (t3);
   memcpy (&mbufs[1].m_dat[100-MHEAD], t3, sizeof(t3));
   sum = cksum (&mbufs[1], sizeof(t3));
   printf ("sum = >%04X\n", sum);

   mbufs[1].m_off = MHEAD;
   mbufs[1].m_len = sizeof (t4);
   memcpy (mbufs[1].m_dat, t4, sizeof(t4));
   sum = cksum (&mbufs[1], sizeof(t4));
   printf ("sum = >%04X\n", sum);

   mbufs[1].m_off = MHEAD;
   mbufs[1].m_len = sizeof (t5);
   memcpy (mbufs[1].m_dat, t5, sizeof(t5));
   sum = cksum (&mbufs[1], sizeof(t5));
   printf ("sum = >%04X\n", sum);
#endif
}
