
struct ucb {                    /* user connection block */
	struct socket uc_host;          /* foreign host address */
	struct socket uc_local;		/* local host address */
	struct proc *uc_proc;           /* -> user proc */
	union {                         /* -> protocol control block */
		char *unull;                    /* general */
		struct tcb *utcb;               /* ->tcb (tcp) */
		struct proto *uproto;		/* ->proto blcok (raw) */
		struct {
			unsigned short u_lport;	/* udp local port */
			unsigned short u_fport;	/* udp foreign port */
		} U_udp;
	} U_cp;
#define uc_tcb  U_cp.utcb
#define uc_proto U_cp.uproto
#define uc_udp U_cp.U_udp
	struct ifcb *uc_srcif;		/* -> source ifcb */
	struct host *uc_route;		/* -> host entry for local net route */
	struct mbuf *uc_sbuf;           /* -> user send buffer */
	struct mbuf *uc_rbuf;           /* -> user receive buffer */
	unchar uc_snd;			/* # send bufs allocated */
	unchar uc_rcv;			/* # receive bufs allocated */
	unchar uc_ssize;		/* # bufs on send buffer */
#define uc_timeo uc_ssize               /* user timeout parameter */
	unchar uc_rsize;		/* # bufs on receive buffer */
	unsigned short uc_xstat;	/* network status word */	
	unsigned short uc_state;	/* state of this connection */
	unsigned short uc_flags;	/* misc. flags (see con.h) */
};

#include "con.h"

#ifdef KERNEL
extern struct ucb *contab, *conNCON;           /* ->start, end of connection table */
extern int nnetcon;
#endif /* KERNEL */

