#include <stdio.h>
#include <sys/types.h>

#include "../include/param.h"
#include "../include/inode.h"
#include "mbuf.h"
#include "net.h"
#include "ifcb.h"
#include "tcp.h"
#include "ip.h"
#include "ucb.h"
#include "fsm.h"
#include "../include/buf.h"
#include "../include/user.h"
#include "../include/proc.h"
#include "../include/reg.h"
#include "../include/file.h"

/* netmain.c */
netlog(mp, s)
struct mbuf *mp;
char *s;
{
#ifdef DEBUG_LOG
	printf ("ERROR: %s: mbuf = >%04X\n", s, mp);
#endif
	m_freem(mp);
	return;
}

/* OS stubs */

void
wakeup()
{
	return;
}

void
ksleep()
{
}

void
psignal()
{
	return;
}

int
ufalloc()
{
	register int i;

	for (i=0; i<NOFILE; i++)
		if (u.u_ofile[i] == NULL) {
			u.u_ar0[R0] = i;
			return(i);
		}
	u.u_error = EMFILE;
	return(-1);
}

struct file *
falloc()
{
	register struct file *fp;
	register int i;

	i = ufalloc();
	if (i < 0)
		return(NULL);
	for (fp = &file[0]; fp < &file[NFILE]; fp++)
		if (fp->f_count==0) {
			u.u_ofile[i] = fp;
			fp->f_count++;
			fp->f_offset = 0;
			return(fp);
		}
	printf("no file\n");
	u.u_error = ENFILE;
	return(NULL);
}

int
frelse(fd)
{
   return (0);
}

int
spl0()
{
	return 0;
}


int
spl4()
{
	return 0;
}

int
spl5()
{
	return 0;
}

int
splx()
{
	return 0;
}
