/*#define DEBUG*/
#include <unistd.h>
#include <errno.h>

#include "net.h"
#include "mbuf.h"
#include "ucb.h"
#include "usr.h"

void
usr_init ()
{
   struct usrwork *w;
   int i;

#ifdef DEBUG
   printf ("usr_init: entered\n");
#endif
   memset (&usrque, 0, sizeof (usrque));
   w = &usrque[0];
   for (i = 0; i < NCON-1; i++) {
      w->usr_next = w+1;
      w++;
   }
   usrfree = &usrque[0];
   usrwork = NULL;
}

int
usr_enque (up, top, len)
struct ucb *up;
struct mbuf *top;
{
   struct usrwork *w;

#ifdef DEBUG
   printf ("usr_enque: entered: up = >%p, top = >%p, len = %d\n", up, top, len);
#endif
   if ((w = usrfree) == NULL) {
      return -1;
   }

#ifdef DEBUG
   printf ("   w = >%p\n", w);
#endif

   usrfree = w->usr_next;
   w->usr_ucb = up;
   w->usr_top = top;
   w->usr_len = len;
   w->usr_next = usrwork;
   usrwork = w;
   return 0;
}

struct usrwork *
usr_deque ()
{
   struct usrwork *w;

   if ((w = usrwork) == NULL) {
      return NULL;
   }

#ifdef DEBUG
   printf ("usr_deque: w = >%p, up = >%p, top = >%p, len = %d\n",
	    w, w->usr_ucb, w->usr_top, w->usr_len);
#endif
   usrwork = w->usr_next;
   w->usr_next = NULL;
   return w;
}

void
usr_free (wp)
struct usrwork *wp;
{
#ifdef DEBUG
   printf ("usr_free: entered: wp = >%p\n", wp);
#endif
   wp->usr_next = usrfree;
   usrfree = wp;
}
